/* Lista by Luigi D'Angelo e Livio Ottaiano - info: jimmcangel@inwind.it */

#include <iostream.h>

 struct nodo
 {
  int n;
  nodo *next;
 };

class lista
{
 public:
 friend class iterator;
 nodo *testa;
 lista () {testa=NULL;};
 lista (const lista &list);//costruttore copy
 ~lista ();
 void canc_lista (nodo* &p);
 void copia (nodo* p,nodo* &q);
 int length (nodo* p); //lunghezza di una lista
 void push (nodo* &p,int x);
 void ins_ord (nodo* &p,int x); //inserimento ordinato di un elemento
// void ins_coda (nodo* &p,int x); //inserimento in coda
 //void ins (nodo* &p,int x); //inserimento in una data posizione
 void pop (nodo* &p,int &x);
 //void del_coda (nodo* &p,int &x); //cancellazione in coda
 int del_ord (nodo* &p,int &x); //cancellazione di un elemento in una lista ordinata
 //int del_nonord (nodo* &p,int &x); //cancellazione di un elemento in una lista generica
 int del_all_ord (nodo* &p,int &x); //cancellazione di tutte le occorrenze di un elemento in una lista ordinata
 //int del_all_nonord (nodo* &p,int &x); //cancellazione di tutte le occorrenze di un elemento in una lista non
//ordinata
 void canc_pari (nodo* &p); //cancellazione degli elementi di posto pari
 void canc_dispari (nodo* &p); //cancellazione degli elementi di posto dispari 
 //int ric_nonord (nodo *p,int x); //ricerca di un elemento in una lista generica
 int ric_ord (nodo *p,int x); //ricerca di un elemento in una lista ordinata
 void visual (nodo *p);
 lista operator= (lista list);
 lista operator+ (lista list);
 void somma (nodo* p1,nodo* p2,nodo* &p3);
 friend lista operator+ (lista list,int x);
 friend lista operator+ (int x,lista list);
 void somma_int (nodo* p1,int x,nodo* &p3);
 lista operator- ();
 void inversion (nodo* &p);
 void ordina (nodo* p); //ordinamento di una lista
 lista fusione_ord (nodo *p1,nodo *p2);//fusione di due liste ordinate
// lista fusione (nodo* &p1,nodo* &p2); //fusione di due liste non ordinate
 void concatena (nodo *p1,nodo *p2); //concatenemento di due liste
 void swap (nodo *p); 
};

//------------------------------------------------------------
class iterator
{
 lista *l;
 nodo *n;
 public:
 iterator (lista &list) {l=&list;};
 void rewind() {n=l->testa;};
 void nodo_next () {n=n->next;};
 int  getn () {return n->n;};
 nodo* get_nodo () {return n;};
};
//------------------------------------------------------------

lista::~lista ()
{
 canc_lista(testa);
 cout<<"\nLista distrutta";
}

void lista::canc_lista (nodo* &p)
{
 if (p)
 {
  canc_lista(p->next);
  delete p;
 }
}

void lista::push (nodo* &p,int x)
{
 nodo *q;
 q=new nodo;
 q->n=x;
 q->next=p;
 p=q;
}

void lista::pop (nodo* &p,int &x)
{
 if (p)
 {
  nodo *q;
  q=p;
  x=p->n;
  p=p->next;
  delete q;
 }
}
  
void lista::visual (nodo *p)
{
 if (p)
 {
  cout<<p->n<<" ";
  visual (p->next);
 }
}

/*int lista::ric_nonord (nodo *p,int x)
{
 if (p)
 {
  if (p->n==x) 
  {
   cout<<"\nElemento trovato all'indirizzo: "<<p;
   return 1;
  }
  else ric_nonord (p->next,x);
 }
 else return 0;
}*/

int lista::ric_ord (nodo *p,int x)
{
 if (p)
 {
  if (p->n==x) 
  {
   cout<<"\nElemento trovato all'indirizzo: "<<p;
   return 1;
  }
  if (p->n<x) ric_ord (p->next,x);
  if (p->n>x) 
  {
   cout<<"\nElemento non presente";
   return 0;
  }
 }
 else return 0;
}

void lista::ins_ord (nodo* &p,int x)
{
 if (p)
 {
  if (p->n>x) push(p,x);
  else ins_ord (p->next,x);
 }
 else push(p,x);
}

/*void lista::ins_coda (nodo* &p,int x)
{
 if (p) ins_coda (p->next,x);
 else push(p,x);
}*/

/*void lista::del_coda (nodo* &p,int &x)
{
 if (p) del_coda (p->next,x);
 else pop (p,x);
}*/
 
int lista::del_ord (nodo* &p,int &x)
{
 if (p)
 {
  if (p->n==x) 
  {
   pop(p,x);
   return 1; 
  }
  if (p->n<x) del_ord (p->next,x);
  if (p->n>x) 
  {
   cout<<"\nElemento non presente";
   return 0;
  }
 }
 else return 0;
} 

/*int lista::del_nonord (nodo* &p,int &x)
{
 if (p)
 {
  if (p->n==x)
  {
   pop(p,x);
   return 1;
  }
  else del_nonord (p->next,x);
 }
 else return 0;
}*/ 

void lista::canc_pari (nodo* &p)
{
 if (p)
 {
  int x;
  pop(p->next,x);
  canc_pari(p->next);
 }
}

void lista::canc_dispari (nodo* &p)
{
 if (p)
 {
  int x;
  pop(p,x);
  canc_dispari (p->next);
 }
}


int lista::length (nodo *p)
{
 if (p)
 {
  nodo *q;
  q=p;
  int i=0;
  while (q) 
  {
   q=q->next;
   i++;
  }
  return i;
 }
 return 0;
}

/*void lista::ins (nodo* &p,int x)
{
 if (p)
 {
  int pos;
  cout<<"\nIn quale posizione vuoi inserire l'elemento "<<x<<"? ";cin>>pos;
  if (pos<length(p)) 
  {
   nodo *q;
   q=p;
   for (int i=1;i<pos;i++) q=q->next;
   push (q,x);
  }
 }
 else push(p,x);
}*/

int lista::del_all_ord (nodo* &p,int &x)
{
 if (p)
 {
  int tot=0;
  nodo *q;
  q=p;
  for (int i=0;i<length(p);i++)
  {
   if (q->n==x)
   {
    pop(q,x);
    q=q->next;
    tot++;
   }
   if (q->n<x) q=q->next;
   if (q->n>x) return tot;
  }
 }
 return 0;
}

/*int lista::del_all_nonord (nodo* &p,int &x)
{
 if (p)
 {
  nodo *q;
  q=p;
  int tot=0;
  for (int i=0;i<length(p);i++)
  {
   if (q->n==x)
   {
    pop (q,x);
    q=q->next;
    tot++;
   }
   else q=q->next;
  }
  return tot;
 }
 return 0;
} */ 


void lista::copia (nodo* p,nodo* &q)
{
 if (p)
 {
  q=new nodo;
  q->n=p->n;
  copia(p->next,q->next);
 }
 else q=NULL;
}

lista::lista (const lista &list)
{
 copia(list.testa,testa);
}

lista lista::operator= (lista list)
{
 canc_lista(testa);
 copia(list.testa,testa);
 return *this;
}


void lista::somma (nodo* p1,nodo* p2,nodo* &p3)
{
 if (p1)
 {
  p3=new nodo;
  p3->n=p1->n+p2->n;
  somma (p1->next,p2->next,p3->next);
 }
}

lista lista::operator+ (lista list)
{
 lista temp;
 if (length(testa)==length(list.testa))
 {
  if (!testa && !list.testa)
  {
   somma (testa,list.testa,temp.testa);
   return temp;  
  }  
 }
 return temp;
}

void lista::somma_int (nodo* p1,int x,nodo* &p3)
{
 if (p1)
 {
  p3=new nodo;
  p3->n=p1->n+x;
  somma_int (p1->next,x,p3->next);
 }
}

lista operator+ (lista list,int x)
{
 lista temp;
 temp.somma_int (list.testa,x,temp.testa);
 return temp;
}

lista operator+ (int x,lista list)
{
 lista temp;
 temp.somma_int (list.testa,x,temp.testa);
 return temp;
}

lista lista::operator- ()
{
 lista temp(*this);
 temp.inversion(temp.testa);
 return temp;
}

void lista::inversion (nodo* &p)
{
 nodo *q;
 if (p)
 {
  if (p->next)
  {
   q=p;
   p=p->next;
   inversion(p);
   q->next->next=q;
   q->next=NULL;
  }
 }
}

void lista::swap (nodo* p)
{
 int temp;
 temp=p->n;
 p->n=p->next->n;
 p->next->n=temp;
}

void lista::ordina (nodo* p)
{
 int i,j;
 for (j=1;j<length(p);j++)
 {
  for (i=0;i<length(p)-j;i++)
  {
   if (p->n>p->next->n) swap(p);
   p=p->next;
  }
 }
}

void lista::concatena (nodo *p1,nodo *p2)
{
 iterator iter(*this);
 copia(p1,testa);
 for (int i=0;i<length(testa)-1;i++) iter.nodo_next();
 nodo *q,*z;
 q=iter.get_nodo();
 copia(p2,z);
 q->next=z;
}

/*lista lista::fusione (nodo* &p1,nodo* &p2)
{
 ordina (p1);
 ordina (p2);
 lista temp;
 temp=concatena(p1,p2);
 ordina(temp.testa);
 return temp;
}*/

lista lista::fusione_ord (nodo *p1,nodo *p2)
{
 lista temp;
 temp.concatena(p1,p2);
 ordina(temp.testa);
 return temp;
}

void f(lista &list)
{
 int x;
 int scelta;
 do
 {
  cout<<"\nInserisci l'elemento:  ";cin>>x;
  list.ins_ord(list.testa,x);
  cout<<"\nVuoi continuare a farti del male? (1=si)  ";cin>>scelta;
 }
 while (scelta==1);
}

void main ()
{
 cout<<"\nLISTE ORDINATE\n\n\n\n";
 int risp=0;
 lista list,list2,list3;
 do
 {
  cout<<"\nMenu':";
  cout<<"\n0.  Esci";
  cout<<"\n1.  Inserimento";
  cout<<"\n2.  Cancellazione di un'occorrenza di un elemento";
  cout<<"\n3.  Cancellazione degli elementi di posto pari";
  cout<<"\n4.  Cancellazione degli elementi di posto dispari";
  cout<<"\n5.  Cancellazione di tutte le occorrenze di un elemento";
  cout<<"\n6.  Ricerca di un elemento";
  cout<<"\n7.  Creazione di un'altra lista";
  cout<<"\n8.  Inversione della lista";
  cout<<"\n9.  Fusione di due liste";
  cout<<"\n10. Concatenamento di due liste";
  cout<<"\n11. Somma di un intero agli elementi di una lista";
  cout<<"\n12. Somma di due liste\n\n\n";
  cin>>risp;
  int x;
  switch (risp)
  {
   case 1: cout<<"\nInserisci l'elemento:  ";
           cin>>x;list.ins_ord(list.testa,x);list.visual (list.testa);
           break;
   case 2: cout<<"\nInserisci l'elemento:  ";
           cin>>x;list.del_ord(list.testa,x);list.visual (list.testa);
           break;
   case 3: list.canc_pari (list.testa);list.visual (list.testa);
           break; 
   case 4: list.canc_dispari (list.testa);list.visual (list.testa);
           break;
   case 5: cout<<"\nInserisci l'elemento:  ";
           cin>>x;list.del_all_ord (list.testa,x);list.visual (list.testa);
           break;
   case 6: cout<<"\nInserisci l'elemento:  ";
           cin>>x;list.ric_ord (list.testa,x);list.visual (list.testa);
           break;
   case 7: cout<<"\Lista creata........";
           break;
   case 8: list2=-list;list2.visual(list2.testa);
           break;
   case 9: f(list2);list3=list3.fusione_ord(list.testa,list2.testa);
           list3.visual(list3.testa);
           break;
   case 10: f(list2);list3.concatena(list.testa,list2.testa);
            list3.visual(list3.testa);
            break;
   case 11: cout<<"\nInserisci l'intero:  ";cin>>x;
            list2=list+x;list2.visual (list2.testa);
            break;
   case 12: f(list2);list3=list+list2;list3.visual(list3.testa);
            break;
  }
 }
 while (risp!=0);
}
